<h1 align="center">ComposeCookBook</h1>

<div align="center">
  <strong>Declarative UI</strong>
</div>
<div align="center">
  A Collection of all Jetpack compose UI elements, Layouts, Widgets and Demo screens to see it's potential.
</div>
<div align="center">
 <img src = "https://github.com/Gurupreet/ComposeCookBook/blob/master/screens/composelogo.png" width = "300px"/>
</div>

<br />

<div align="center">
  <a href = "https://github.com/Gurupreet/ComposeCookBook/network/">
    <img src = "https://img.shields.io/github/forks/Gurupreet/ComposeCookBook" />
  </a>
  <a href = "https://github.com/Gurupreet/ComposeCookBook/stargazers">
     <img src = "https://img.shields.io/github/stars/Gurupreet/ComposeCookBook" />
  </a>
  <a href = "https://github.com/Gurupreet/ComposeCookBook/issues">
     <img src = "https://img.shields.io/github/issues/Gurupreet/ComposeCookBook" />
  </a>  
    <a href = "https://github.com/Gurupreet/ComposeCookBook/blob/master/LICENSE">
     <img src = "https://img.shields.io/github/license/Gurupreet/ComposeCookBook" />
  </a> 
  <a href = "https://twitter.com/_gurupreet">
     <img src = "https://img.shields.io/twitter/url?label=follow&style=social&url=https%3A%2F%2Ftwitter.com%2F_gurupreet" />
  </a>
</div>

# Jetpack Compose
Jetpack Compose is Android’s modern toolkit for building native UI. It simplifies and accelerates UI development on Android. Quickly bring your app to life with less code, powerful tools, and intuitive Kotlin APIs.

## Screens
List & Layouts             |  Widgets and building blocks| Animations
:-------------------------:|:-------------------------: | :-------------------------:
![](https://media.giphy.com/media/WOlo2cTDdjGkgdAJQK/giphy.gif)  |  ![](https://media.giphy.com/media/RkEyxCn43aX1MoIdcx/giphy.gif) | ![](https://media.giphy.com/media/pZfwwwOlKQtiyJFPr2/giphy.gif)

### Demo UI
Spotify             |  Instagram Demo | Twitter, Gmail, Youtube                       | Profile
:-------------------------:|:-------------------------: | :-------------------------: | :-------------------------:
![](https://media.giphy.com/media/IddlpOpdboqJwdhxMS/giphy.gif)  |  ![](https://media.giphy.com/media/XSh4SKvAgr6Moj3SDH/giphy.gif) | ![](https://media.giphy.com/media/sEe1vREivaK7ieMPYj/giphy.gif) | ![](https://media.giphy.com/media/n3UTF9SzLpBGneFyj3/giphy.gif)


### Apps with Api, Retrofit, Room, Flow, Livedata Integration
CryptoApp MVVM             |  MovieApp MVI(In progress)
:-------------------------:|:-------------------------:
![](https://media.giphy.com/media/OtJXUCh2ITINfKuTc0/giphy.gif)  |  ![](https://media.giphy.com/media/BfHMR2EMJkzB1agvpk/giphy.gif)


## How to get started
Please get **android studio 4.2 canary 8** or above to build this project [from here](https://developer.android.com/studio/preview/).

## Features & Where to start
- __Widgets:__ Widgets Screen show case all the available components to build UI.
- __Home Screen:__ Start with Layouts, Modifiers and Simple Listviews
- __Demo UI:__ Learn how demo UI have been made by using layouts, listviews and widgets.
- __Animations:__ Animations are very interesting in compose. Checkout single value animations to get started.
- __Others:__ After the above steps feel free to deep dive into Tablayouts, carousel, Dialogs and BottomSheets 

## Official Documentations
- Official Google Documentation
  - [Jetpack compose](https://developer.android.com/jetpack/compose)
  - [Jetpack compose Samples](https://github.com/android/compose-samples)
  - [Jetpack Compose Codelabs](https://codelabs.developers.google.com/codelabs/jetpack-compose-layouts/index.html#0)
  
- [Compose Academy ](https://compose.academy/)

## Contribution Info
- All the contributions are welcomed keeping following points in mind.
  - If it's a widget/tool/UI element newly added please add to Widget Screen
  - Any feature showcase like Collapsing AppBar, BottomSheets, Dialogs etc add in HomeScreen list
  - Any Demo UI please add to Demo UI section
  - Try not to add new Icons/Images unless must be needed.
  - Please make sure whatever you add also supports dark mode as well.
  Thanks happy coding 


## Please Share & Star the repository to keep me motivated.
  <a href = "https://github.com/Gurupreet/ComposeCookBook/stargazers">
     <img src = "https://img.shields.io/github/stars/Gurupreet/ComposeCookBook" />
  </a>
  <a href = "https://twitter.com/_gurupreet">
     <img src = "https://img.shields.io/twitter/url?label=follow&style=social&url=https%3A%2F%2Ftwitter.com%2F_gurupreet" />
  </a>

